<?php
// Nagios XI Graph Explorer index
//  
// Copyright (c) 2011 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: eventlog.php 359 2010-10-31 17:08:47Z egalstad $
require_once(dirname(__FILE__) . '/../../common.inc.php');
include_once(dirname(__FILE__) . '/dashlet.inc.php');
require_once(dirname(__FILE__) . '/visFunctions.inc.php');

// initialization stuff
pre_init();
init_session();
grab_request_vars();
check_prereqs();
check_authentication(false);

// Do the actual page start
do_page_start(array("page_title" => gettext("Nagios Graph Explorer")), true);

?>
<script type="text/javascript">

    <?php $rand = rand(); ?>

    /////////////////js page variables ////////////////////////
    var filtering = false;
    var host;
    var service;
    var type;
    var filter;
    var start;
    var end = '';
    var minus = true;
    var rand = '<?php echo $rand; ?>';
    var opt = '';

    ////////////////////////////////////////////////////////////
    // Creating a Dashlet...
    ////////////////////////////////////////////////////////////

    $(document).ready(function () {

        // Default page load
        ge_default_page_load();

    });

    // Do default page load
    function ge_default_page_load() {
        setType('bar');
        fetch_bar();
        $('#showBar').parent().addClass('selectedTab');
    }

    // Do display dashlet created
    function ge_display_dashlet_created() {
        txtHeader = get_language_string('AddToDashboardSuccessHeader');
        txtMessage = get_language_string('AddToDashboardSuccessMessage');
        content = "<div id='child_popup_header'><b>" + txtHeader + "</b></div><div style='height: 100px;' id='child_popup_data'><p>" + txtMessage + "</p></div>";
        set_child_popup_content(content);
        display_child_popup();
        $('#child_popup_layer').css('height', '80px'); // Overrideing built in resizing
        fade_child_popup('green', 2000);
    }

    function ge_add_graph_to_dashlet() {
        var board = $('#boardName').val();
        var dashletname = $('#dashletName').val();
        var hiddenurl = $('#hiddenUrl').val();

        // Send request to dashify
        $.post("dashifygraph.php", {url: hiddenurl, dashletName: dashletname, boardName: board}, function (data) {

            // If it was a success show created message
            if (data.success == 1) {
                ge_display_dashlet_created();
            }

        }, 'json');
    }

</script>
<!-- graph explorer JS functions -->
<script type="text/javascript" src="graphexplorer.js"></script>
<style type="text/css">

    h3 {
        margin: 8px auto;
        text-align: center;
        padding: 8px 0px 10px 0px;
        height: 16px;
        font-size: 14px;
    }

    ul, li {
        text-indent: 0px;
        margin: 0px;
        padding: 0px;
    }

    ul.childUl {
        padding-left: 5px;
    }

    .parentLi {
        color: #4D89F9;
        list-style: none;
        padding-left: 0px;
        width: 100%;
    }

    .parentLi:hover {
        cursor: pointer;
    }

    .parentLi:before {
        content: url('images/expand1.png');
        display: inline;
    }

    .childLi {
        text-indent: 1px;
        background-color: #DEDEDE;
        margin: 1px;
        padding: 1px 1px 1px 8px;
        list-style: none;
    }

    .childLi:hover {
        cursor: pointer;
    }

    .childLi a {
        width: 100%;
    }

    #leftContainer {
        clear: left;
        float: left;
        width: 20%;
        height: 800px;
        overflow: auto;
        margin: 5px;
        display: none;
        min-width: 200px;
    }

    #leftNav {
        overflow: auto;
    }

    #rightContainer {
        width: 75%;
        margin: 5px auto;
    }

    .expand:before {
        content: url('images/collapse.png');
        display: inline;
    }

    select {
        width: auto;
    }

    #vtkNavLinks {
        border-bottom: 1px solid #AAA;
        clear: right;
        height: 30px;
        min-width: 700px;
    }

    .vtkNav {
        float: left;
        display: block;
        margin: 1px;
        border: 1px solid #AAA;
        padding: 5px 10px 9px 10px;
        background: #EDEDED;
        border-top-right-radius: 5px;
        border-top-left-radius: 5px;
        height: 14px;
    }

    .selectedTab {
        border-bottom: #FFF;
        background: #FFF;
        padding-bottom: 10px;
        z-index: 1000;
    }

    p.message {
        text-align: center;
    }

    #startDate, #endDate {
        background-color: #DEDEDE;
    }

    .childcontentthrobber {
        margin: 30px auto;
        height: 300px;
        text-align: center;
    }

    #startdatepickercontainer {
        right: 110px;
    }

    /* Datetime picker fix */

    /* Stack Service Styles */
    #service_stack_div {
        padding-top: 15px;
    }

    #service_stack {
        margin: 20px 0;
    }

    #service_stack div {
        padding: 5px;
        line-height: 16px;
        background-color: #EEE;
        margin-bottom: 4px;
    }

    #service_stack div img {
        cursor: pointer;
        vertical-align: top;
        padding-right: 6px;
    }
</style>

<h3><?php echo gettext("Nagios Graph Explorer"); ?></h3>

    <div id='tabs'>
        <ul id='vtkNavLinks'>
            <li class='vtkNav'><a class="tab" id='showBar'
                                  href='javascript:setType("bar"); javascript:fetch_bar(); javascript:toggle_filter();'
                                  title="Shows the top alert producers for the last 24 hours"> <?php echo gettext("Top Alerts Last 24hrs"); ?> </a>
            </li>
            <li class='vtkNav'><a class="tab" id='showPieHost'
                                  href='javascript:setType("pie"); javascript:fetch_pie("hosthealth"); javascript:toggle_filter();'
                                  title="Shows host health percentage as a pie graph."> <?php echo gettext("Host Health"); ?> </a>
            </li>
            <li class='vtkNav'><a class="tab" id='showPieService'
                                  href='javascript:setType("pie"); javascript:fetch_pie("servicehealth"); javascript:toggle_filter();'
                                  title="Shows service health percentage as a pie graph."> <?php echo gettext("Service Health"); ?> </a>
            </li>
            <li class='vtkNav'><a class="tab" id='showTimeline'
                                  href='javascript:setType("timeline"); javascript:toggle_filter("timeline");'
                                  title="Shows performance data on a scalable timeline."> <?php echo gettext("Scalable Performance Graph"); ?> </a>
            </li>
            <li class='vtkNav'><a class="tab" id='showStack'
                                  href='javascript:setType("stack"); javascript:toggle_filter("stack");'
                                  title="Shows performance data with overlapping timeperiods for comparison."> <?php echo gettext("Time Stacked Performance Graph"); ?> </a>
            </li>
            <li class='vtkNav'><a class="tab" id='showObjectStack'
                                  href='javascript:setType("multistack"); javascript:toggle_filter("multistack");'
                                  title="Multistacked performance data with overlapping services and/or hosts for comparison."> <?php echo gettext("Multistacked Performance Graph"); ?> </a>
            </li>
        </ul>
    </div>

    <?php
    $auto_start_date = get_datetime_string(strtotime('yesterday'), DT_SHORT_DATE);
    $auto_end_date = get_datetime_string(strtotime('Today'), DT_SHORT_DATE);
    ?>

    <script type="text/javascript">
        $(document).ready(function () {
            $('#startdateBox').click(function () {
                $('#timeperiod_select').val('custom');
                if ($('#startdateBox').val() == '' && $('#enddateBox').val() == '') {
                    $('#startdateBox').val('<?php echo $auto_start_date;?>');
                    $('#enddateBox').val('<?php echo $auto_end_date;?>');
                }
            });
            $('#enddateBox').click(function () {
                $('#timeperiod_select').val('custom');
                if ($('#startdateBox').val() == '' && $('#enddateBox').val() == '') {
                    $('#startdateBox').val('<?php echo $auto_start_date;?>');
                    $('#enddateBox').val('<?php echo $auto_end_date;?>');
                }
            });
        });
    </script>

    <div id="leftContainer">

        <!-- Host/Service Selection -->
        <div id="host_service_selection">
            <h4><?php echo gettext("Graph Objects"); ?></h4>

            <div>
                <label for='selectHost'><?php echo gettext("Select Host"); ?></label><br/>
                <select name='selectHost' id='selectHost' style="width: 255px; height: 20px;">
                    <!-- AJAX load all hosts -->
                    <option value=''> &nbsp; </value>
                </select>
            </div>
            <div>
                <label for='selectService'><?php echo gettext("Select Service"); ?></label><br/>
                <select name='selectService' id='selectService' style="width: auto; max-width: 320px;">
                    <!-- AJAX load services on select -->
                    <option value=''><?php echo gettext("Select a host..."); ?></option>
                </select>
            </div>
            <div id="selectDataTypeBox">
                <label for="selectDataType"><?php echo gettext("Select Data Type"); ?></label><br/>
                <select id="selectDataType">
                    <!-- AJAX load data types for object or hide -->
                </select>
            </div>
            <div id="service_stack_div">
                <div>
                    <button id="addToGraph" type="button"><?php echo gettext("Add To Graph"); ?></button>
                </div>
                <div id="service_stack">
                    <!-- AJAX populated stack of services -->
                </div>
            </div>
            <h4><?php echo gettext("Filtering Options"); ?></h4>

            <div id="dateFilterTimeline">
                <label><?php echo gettext("Time Period"); ?></label><br/>
                <select id="reportperiodDropdown" name="timeperiod" style="width: 140px; margin-bottom: 5px;">
                    <option value="-4h"><?php echo gettext("Last 4 Hours"); ?></option>
                    <option value="-24h"><?php echo gettext("Last 24 Hours"); ?></option>
                    <option value="-48h"><?php echo gettext("Last 48 Hours"); ?></option>
                    <option value="-1w"><?php echo gettext("Last Week"); ?></option>
                    <option value="-1m"><?php echo gettext("Last Month"); ?></option>
                    <option value="-1y"><?php echo gettext("Last Year"); ?></option>
                    <option value="custom"><?php echo gettext("Custom"); ?></option>
                </select> <?php echo gettext("or"); ?><br/>

                <div>
                    <input type="text" id="startdateBox" name="startdate" style="width: 116px; margin-right: 5px;">

                    <div class="reportstartdatepicker"><img src="<?php echo theme_image("calendar_small.png"); ?>">
                    </div>
                    <div id="startdatepickercontainer"></div> <?php echo gettext("to"); ?>
                </div>
                <div style="margin-top: 5px;">
                    <input type="text" id="enddateBox" name="enddate" style="width: 116px; margin-right: 5px;">

                    <div class="reportenddatepicker"><img src="<?php echo theme_image("calendar_small.png"); ?>"></div>
                    <div id="enddatepickercontainer"></div>
                </div>
            </div>
        </div>

        <!-- Filter Options -->
        <div id="filterDiv">
            <div id='dateFilterStack'>
                <label for='timeStackOpt'><?php echo gettext("Select Time Frame"); ?></label><br/>
                <select name='timeStackOpt' id='timeStackOpt' style="width: 150px;">
                    <option value='days'> <?php echo gettext("Last 3 Days"); ?> </option>
                    <option value='weeks'> <?php echo gettext("Last 3 Weeks"); ?> </option>
                    <option value='months'> <?php echo gettext("Last 3 Months"); ?> </option>
                </select>
            </div>
        </div>

        <div id="graphOptions">
            <h4><?php echo gettext("Graph Options"); ?></h4>

            <div>
                <label for="linetype"><?php echo gettext("Line Type"); ?></label><br/>
                <select name="linetype" id="linetype" style="width: auto; max-width: 320px;">
                    <option value="area"><?php echo gettext("Area"); ?></option>
                    <option value="line"><?php echo gettext("Line"); ?></option>
                    <option value="spline"><?php echo gettext("Spline"); ?></option>
                </select>
            </div>
        </div>

        <div style="margin-top: 15px;">
            <button id='filterButton' type="button"><?php echo gettext("Update Graph"); ?></button>
        </div>

    </div>
    <!-- end leftContainer -->

    <div id="rightContainer">

        <div id="graphText" style="display: none; padding: 40px 0; text-align: center;">
            <?php echo gettext("Select services to stack on the left. Less services and similar services makes a better, more readable graph. Filter by the desired time."); ?>
            <br/>
            <br/>
            <strong><?php echo gettext("Only hosts/services with performance data will show up on the lists."); ?></strong>

            <div id="test" style="padding-top: 20px;"></div>
        </div>

        <div id="graphDisplay">
            <div class='dashifybutton2'>
                <a class='dashifybutton2' id='dashify2' href='#'
                   title='<?php echo gettext('Add This To a Dashboard'); ?>'>
                    <img src='<?php echo get_base_url(); ?>/images/dashify.png'></a>
            </div>

            <!-- attempting to pass args for dashlet creation -->
            <input type='hidden' id='hiddenUrl' name='url' value=''/>
            <input type='hidden' id='dashletName' name='dashletName' value=''/>
            <input type='hidden' id='boardName' name='boardName' value=''/>

            <div class='viewer' id="visContainer<?php echo $rand; ?>">
                <!-- javascript magic here -->
                <div class="childcontentthrobber" id='childcontentthrobber'>
                    <img src="/nagiosxi/images/throbber1.gif"/>
                </div>
            </div>
        </div>

    </div>

</body>
</html>