<?php
//
// Copyright (c) 2008-2014 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: page-home-main.php 2854 2014-08-23 18:29:04Z swilkerson $

require_once(dirname(__FILE__) . '/common.inc.php');

// initialization stuff
pre_init();

// start session
init_session();

// grab GET or POST variables 
grab_request_vars();

// check prereqs
check_prereqs();

// check authentication
check_authentication(false);

do_page();


function do_page()
{

    $default_page_title = "Nagios XI";
    $default_destination = "default";

    // do callbacks to see if components override title or redirect us elsewhere
    $cbargs = array(
        "page_title" => $default_page_title,
        "page_url" => "",
        "redirect_url" => false,
    );
    do_callbacks(CALLBACK_HOME_PAGE_OPTIONS, $cbargs);

    // get returned values
    $destination = grab_array_var($cbargs, "destination", $default_destination);
    $page_title = grab_array_var($cbargs, "page_title", $default_page_title);
    $page_url = grab_array_var($cbargs, "page_url", "");
    $redirect_url = grab_array_var($cbargs, "redirect_url", false);

    if (0) {
        echo "DEST: $destination<BR>";
        echo "TITLE: $page_title<BR>";
        echo "URL: $page_url<BR>";
        echo "RURL: $redirect_url<BR>";
        exit();
    }

    // component wants to redirect to another page
    if ($destination == "custom" && $redirect_url == true && $page_url != "") {
        header("Location: $page_url");
        exit();
    } // component wants to show home dashboard
    else if ($destination == "homedashboard" || use_2012_features() == false) {

        // add some dashboards for the user if they don't have any
        add_default_dashboards();
        ?>
        <h1><?php echo $page_title; ?></h1>
        <?php
        // show the homepage dashboard
        $dashboard = get_dashboard_by_id(0, HOMEPAGE_DASHBOARD_ID);

        $s = "background: #" . $dashboard["opts"]["background"] . ";";

        do_page_start(
            array(
                "body_id" => "dashboard-" . $dashboard["id"],
                "body_class" => "dashboard dashboard-" . $dashboard["id"],
                "body_style" => $s,
                "page_id" => "dashboards-page" . $dashboard["id"],
                "page_class" => "dashboard dashboard-" . $dashboard["id"],
                "page_title" => "Dashboard - " . htmlentities($dashboard["title"]),
            ),
            true
        );

        display_dashboard_dashlets($dashboard);

        do_page_end(true);
        exit();
    } // show default home splash
    else {
        header("Location: page-default-splash.php");
        exit();
    }
}

?>
